﻿from calculeInverseZs256Z import inverseZs256Z

# premier programme de cryptage affine

# Fonction de cryptage affine modulo 256 : les codes sont entre 0 et 255
def cryptageAffine(message,cle):
    a = cle[0]
    b = cle[1]
    messageCrypte = ""
    for x in message:
        messageCrypte = messageCrypte + chr((a*ord(x)+b) % 256)
    return messageCrypte

# Fonction de décryptage affine modulo 256 : les codes sont entre 0 et 255
def decryptageAffine(message,cle):
    a = cle[0]
    b = cle[1]
    ad = inverseZs256Z(a)
    bd = (- ad * b) + 256
    if(bd < 0):
        bd = bd + 256
    messageDecrypte = ""
    for x in message:
        messageDecrypte = messageDecrypte + chr((ad*ord(x)+bd) % 256)
    return messageDecrypte

# Test des fonctions de cryptage et de décryptage
cle = [3,2]
message = "coucou, c'est moi !"
messageCrypte = cryptageAffine(message,cle)
print(messageCrypte)

messageDecrypte = decryptageAffine(messageCrypte,cle)
print(messageDecrypte)